import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class LaserBoltPlayer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class LaserBoltPlayer extends Mover
{
    /**
     * Act - do whatever the LaserBoltPlayer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        int distance = 15;
        World w = getWorld();
            
        if(canMove(distance))
        {
            move(distance);
        }
        else
        {
            w.removeObject(this);
            return;
        }
                
        if(atEdge())
        {
            w.removeObject(this);
            return;
        }
    }    
    
    public boolean canMove(int distance)
    {
        
        int y = getY();
        int x = getX();
        World w = getWorld();
        int width = w.getWidth();
        int height = w.getHeight();
        
        return x + distance < width && y + distance < height;
    }
   
    public boolean atEdge()
    {
        World w = getWorld();
        int worldX = w.getWidth();
        int worldY = w.getHeight();
        int x = getX();
        int y = getY();
        if(x <= 1 || x >= worldX-1 || y <= 1 || y >= worldY-1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
}
