import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class TreskaTurret here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class TreskaTurret extends Mover
{
    /**
     * Act - do whatever the TreskaTurret wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(findEnemy())
        {   
            getCoordinates();
            
            if(canFire())
            {
                fire();
            }
        }
        
        World w = getWorld();
        
        if(getWorld() != null)
        {
            w.removeObject(this);
        }
    }    
    
    public boolean findEnemy()
    {
        List<Actor> ships = getObjectsInRange(400, ship.class);
        return ships.size()>0;
    }
    
    public void getCoordinates()
    {
       World w = getWorld(); 
       List<ship> ships = w.getObjects(ship.class);
       ListIterator<ship> itr = ships.listIterator();
       if(!itr.hasNext())
       {
           return;
       }
       
       ship enemy = itr.next();
       
       int x = enemy.getX();
       int y = enemy.getY();
       
       turnTowards(x,y);
    }
    
    public boolean canFire()
    {
        int trigger = (int)(Math.random()*100)+1;//the chances of firing
        return trigger <= 20;
    }
    
    public void fire()
    {   
        TreskaRound round = new TreskaRound();
        getWorld().addObject(round, getX(), getY());
        round.setRotation(getRotation());
        round.move(40);
    }
    
    
}
