import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class World5 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class World5 extends World
{
    private Lable health_;
    
    private ship player_;
    private Redbaron shnider_;
    
    /**
     * Constructor for objects of class World5.
     * 
     */
    public World5()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(960, 708, 1); 
        
        player_ = new ship();
        addObject(player_, 538, 608);
        
        shnider_ = new Redbaron();
        addObject(shnider_, (int)(getWidth()/2), (int)(getHeight()/10));
        
        health_ = new Lable(100,30);
        health_.setFontSize(20);
        health_.setColor(Color.WHITE);
        health_.setText("Health 100/100");
        int healthX = getWidth() - health_.getImage().getWidth()/2-5;
        int healthY = health_.getImage().getHeight()/2+5;
        addObject(health_, healthX, healthY);
        
    }
    
    public void act()
    {
        health_.setText("Health " + player_.getHealth() + "/100");
        
        if(player_.getWorld() == null)
        {
            Lable gameOver = new Lable(400, 100);
            gameOver.setColor(Color.RED);
            gameOver.setFontSize(40);
            gameOver.setText("Game Over");
            addObject(gameOver, getWidth()/2, getHeight()/2);
            
            Greenfoot.stop();
        }
        else if(shnider_.getWorld() == null)
        {
            Lable youWin = new Lable(400, 100);
            youWin.setColor(Color.RED);
            youWin.setFontSize(40);
            youWin.setText("You Win!");
            addObject(youWin, getWidth()/2, getHeight()/2);
            
            Greenfoot.stop();
        }
        
    }
    
    private void generateHealth()
    {
        int x = (int)(Math.random()*-100)+100;
        int y = Greenfoot.getRandomNumber(100);
        int chance = 25;
        int lx = (int)(Math.random()*300)+600;
        int ly = (int)(Math.random()*700)+707;
        
        if(player_.getHealth() <=50 && y <= chance)
        {
            RepairPack youNeedIt = new RepairPack();
            addObject(youNeedIt, lx, ly);           
        }
    }
}
