import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class missile here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class missile extends Actor
{
    final int distance = 3;
    int health_;
    
    public missile()
    {
        super();
        health_ = 5;
        
    }
    
    /**
     * Act - do whatever the missile wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
            //10:15
        World w = getWorld();
            
        if(canMove(distance))
        {
            fall(distance);
        }
        else
        {
            w.removeObject(this);
        }
        
        if(getWorld() != null)
        {
            if(foundRound())
            {
                getShot();
            }
            else if(foundMissile())
            {
                takeHeavyDamage();
            }
            else if(foundMac())
            {
                getObliterated();
            }
        }
        
        dead();
    }
    
    public void fall(int distance)
    {
        int x = getX();
        int y = getY();
        
        setLocation(x,y + distance);
    }
    
    public boolean canMove(int distance)
    {
        int y = getY();
        int x = getX();
        World w = getWorld();
        int width = w.getWidth();
        int height = w.getHeight();
        
        return x + distance < width && y + distance < height;
    }
    
    public int getHealth()
    {
        return health_;
    }
    
    public boolean foundRound()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        return r != null;
    }
    
    public boolean foundMissile()
    {
        Actor m = getOneIntersectingObject(Missile2.class);
        return  m != null;
    }
    
    public boolean foundMac()
    {
       Actor m = getOneIntersectingObject(Mac.class);
       return m != null;
    }
    
    public void getShot()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        getWorld().removeObject(r);
        health_--;
    }
    
    public void takeHeavyDamage()
    {
        Actor m = getOneIntersectingObject(Missile2.class);
        getWorld().removeObject(m);
        health_ -= 5;
    }
    
    public void getObliterated()
    {
        Actor m = getOneIntersectingObject(Mac.class);
        getWorld().removeObject(m);
        health_ -= 10;
    }
    
    public void turret()
    {
        TreskaTurret t = new TreskaTurret();
        getWorld().addObject(t, getX(), getY());
        t.getCoordinates();
    }
    
    public void dead()
    {
        if(getHealth() <= 0)
        {
            World w = getWorld();
            w.removeObject(this);
        }
    }
}
