import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Base here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Base extends Actor
{
    private int health_;
    private int hpCounter_;
    
    public Base()
    {
        super();
        health_ = 10000;
        hpCounter_ = 0;
    }
    /**
     * Act - do whatever the Base wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(foundBomb())
        {
            getBombed();
        }
        
        if(hpCounter_ >= 100)
        {
            
            healAway();
        }
        
        die();
        
        hpCounter_ ++;
    }    
    
    public int getHealth()
    {
        return health_;
    }
    
    public boolean foundBomb()
    {
        Actor b = getOneIntersectingObject(missile.class);
        return b != null;
    }
    
    public void getBombed()
    {
        Actor b = getOneIntersectingObject(missile.class);
        World w = getWorld();
        w.removeObject(b);
        health_ -= 5;
    }
    
    public void healAway()
    {
       World w = getWorld(); 
       List<ship> ships = w.getObjects(ship.class);
       ListIterator<ship> itr = ships.listIterator();
       if(!itr.hasNext())
       {
           return;
       }
       
       ship enemy = itr.next();
       
       int ehp = enemy.getHealth();
       int x = (int)(Math.random()*-100)+100;
       int y = Greenfoot.getRandomNumber(100);
       int chance = 25;
       if(ehp <=50 && y <= chance)
       {
           RepairPack youNeedIt = new RepairPack();
           w.addObject(youNeedIt, getX() + x, getY() + y);           
       }
       hpCounter_ = 0;
    }
    
    public void die()
    {
        if(getHealth() <= 0)
        {
            getWorld().removeObject(this);
        }
    }
}
