import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.lang.Math;
 /* The most unreliable homing missiles in the world.....
 * 
 * @author (ﾆメシュ) 
 * @version (21/04/013)
 */
public class Missile2 extends Mover
{
    private int count_;
    private int canTrace_;
    public int X;
    public int Y;
    public int sx;
    public int sy;

    public Missile2()
    {
        super();
        
        count_ = 20;
        canTrace_ = 0;
    }
    
    /**
     * Act - do whatever the Missile2 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        int distance = 10;
        World w = getWorld();
            
        if(canMove(distance))
        {
            move(distance);
        }
        else
        {
            w.removeObject(this);
            return;
        }
                
        if(atEdge())
        {
            w.removeObject(this);
            return;
        }
        
        getGoon();
    }
    
    public boolean canMove(int distance)
    {
        
        int y = getY();
        int x = getX();
        World w = getWorld();
        int width = w.getWidth();
        int height = w.getHeight();
        
        return x + distance < width && y + distance < height;
    }
   
    public boolean atEdge()
    {
        World w = getWorld();
        int worldX = w.getWidth();
        int worldY = w.getHeight();
        int x = getX();
        int y = getY();
        if(x <= 1 || x >= worldX-1 || y <= 1 || y >= worldY-1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    //because of problems being implemented by this meathod, its usage has been halted till further development
    public void getRedbaron()
    {
        World w = getWorld(); 
        List<Redbaron> germans = w.getObjects(Redbaron.class);
        ListIterator<Redbaron> itr = germans.listIterator();
        if(!itr.hasNext())
        {
           return;
        }
       
        Redbaron enemy2 = itr.next();
       
        int rx = enemy2.getX();
        int ry = enemy2.getY();
       
        turnTowards(rx, ry);
        
    }
    
    public void getGoon()
    {    
       World w = getWorld();
       
       List<ship> n = w.getObjects(ship.class);
       ListIterator<ship> s = n.listIterator();
       if(!s.hasNext())
       {
           return;
       }
       
       List<Goon> goons = w.getObjects(Goon.class);
       ListIterator<Goon> itr = goons.listIterator();
       if(!itr.hasNext())
       {
           return;
       }
       
       ship shipu = s.next();
       
       int gArrX[] = new int[goons.size()];
       int gArrY[] = new int[goons.size()];
       int rX[] = new int[goons.size()];
       int rY[] = new int[goons.size()];
       int hyp[] = new int[goons.size()];
       int ex;
       int ey;
       
       for(int i = 0; i < gArrX.length; i++)
       {
           Goon enemy = itr.next();
           
           ex = enemy.getX();
           gArrX[i] = ex;
           rX[i] = ex;
           ey = enemy.getY();
           gArrY[i] = ey;
           rY[i] = ey;
           
           sx = shipu.getX();
           sy = shipu.getY();
        }
        
       for(int xy = 0; xy < hyp.length; xy++)
          {
              hyp[xy] = (int)(Math.hypot((double)(gArrX[xy]-sx), (double)(gArrY[xy]-sy)));
          }
        
       int lowest = hyp[0];
        
       for(int t = 0; t < hyp.length; t ++)
          {
              if(lowest > hyp[t])
              {
                  lowest = hyp[t];
                  X = rX[t];
                  Y = rY[t];
              }
          }
       turnTowards(X,Y); 
       turn(30);
    }
}
