import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Treska here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Treska extends Actor
{
    public int health_;
    private int change;
    
    public Treska()
    {
        super();
        health_ = 50;
   
        change = 5;
        
    }
    
    /**
     * Act - do whatever the Treska wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        movement();
        turret();
        
        if(foundRound())
        {
            getShot();
        }
        else if(foundMissile())
        {
            takeHeavyDamage();
        }
        else if(foundMac())
        {
            getObliterated();
        }
        
        dead();
    }    
    
    public void movement()
    {
        int speed = 5;
        World w = getWorld();
        
        move(speed);
        
        if(getX() >= 1171 || getX() <= 2)
        {
                turn(180);         
        }
    }
    
    public int getHealth()
    {
        return health_;
    }
    
    public boolean foundRound()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        return r != null;
    }
    
    public boolean foundMissile()
    {
        Actor m = getOneIntersectingObject(Missile2.class);
        return  m != null;
    }
    
    public boolean foundMac()
    {
       Actor m = getOneIntersectingObject(Mac.class);
       return m != null;
    }
    
    public void getShot()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        getWorld().removeObject(r);
        --health_;
    }
    
    public void takeHeavyDamage()
    {
        Actor m = getOneIntersectingObject(Missile2.class);
        getWorld().removeObject(m);
        health_ -= 5;
    }
    
    public void getObliterated()
    {
        Actor m = getOneIntersectingObject(Mac.class);
        getWorld().removeObject(m);
        health_ -= 10;
    }
    
    public void turret()
    {
        TreskaTurret t = new TreskaTurret();
        getWorld().addObject(t, getX(), getY());
        t.getCoordinates();
    }
    
    public void dead()
    {
        if(getHealth() <= 0)
        {
            World w = getWorld();
            w.removeObject(this);
        }
    }
    
}
