import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;
/**
 * Write a description of class World3 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class World3 extends World
{
    private int canSpawn_;
    private int spawn_;
    private int goons_;
    
    private Lable health_;
    
    private ship player_;
    
    /**
     * Constructor for objects of class World3.
     * 
     */
    public World3()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(1173, 802, 1); 
        
        //add objects
        prepare();
        player_ = new ship();
        addObject(player_, 538, 608);
        generateTreska();
        generateGoon();
        
        //ints/doubles
        canSpawn_ = 200;
        spawn_ = canSpawn_;
        goons_ = 0;
        
        //health lables here
        health_ = new Lable(100,30);
        health_.setFontSize(20);
        health_.setColor(Color.WHITE);
        health_.setText("Health 100/100");
        int healthX = getWidth() - health_.getImage().getWidth()/2-5;
        int healthY = health_.getImage().getHeight()/2+5;
        addObject(health_, healthX, healthY);
        
        //sounds here
    }
    
    public void act()
    {
        health_.setText("Health " + player_.getHealth() + "/100");
        
        if(player_.getWorld() == null)
        {
            Lable gameOver = new Lable(400, 100);
            gameOver.setColor(Color.RED);
            gameOver.setFontSize(40);
            gameOver.setText("Game Over");
            addObject(gameOver, getWidth()/2, getHeight()/2);
            
            Greenfoot.stop();
        }
        
        //a list of objects to change levels
        List <Treska> treska = getObjects(Treska.class);
        List <Goon> goons = getObjects(Goon.class);
        
        if(treska.size() <= 0 && goons.size() <= 0)
        {
            World4 world = new World4();
            Greenfoot.setWorld(world);
        }
        
        generateRunner();
    }
    
    private void prepare()
    {
        Base base = new Base();
        addObject(base, 548, 740);
        base.setLocation(548, 741);
    }
    
    private void generateRunner()
    {
        if(spawn_ == canSpawn_)
        {
            Runner run = new Runner();
            addObject(run, 5, 5);
            spawn_ = 0;
        }
        
        spawn_ ++;
    }
    
    private void generateTreska()
    {
        int x = Greenfoot.getRandomNumber(1171);
        int y = (int)(Math.random()*400) + 200;
        
        for(int treska_ = 0; treska_ <= 4; treska_++)
        {
            Treska treska = new Treska();
            addObject(treska, x, y);
            x = Greenfoot.getRandomNumber(1171);
            y = (int)(Math.random()*400) + 200;
        }
    }
    
    private void generateGoon()
    {
        int x = (int)(Math.random()*1170) + 1;
        int y = (int)(Math.random()*200) + 1;

        while(spawn_ >= canSpawn_ && goons_ <= 10)
        {
            Goon goon = new Goon();
            addObject(goon, x, y);
            spawn_ = 0;
            goons_ ++;
            x = (int)(Math.random()*1170) + 1;
            y = (int)(Math.random()*200) + 1;
        }
        
        spawn_++;
    }
    
    
}
