import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;
/**
 * Write a description of class World4 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class World4 extends World
{   
    private int canSpawn_;
    private int spawn_;
   
    private Lable health_;
    
    private ship player_;
   
    /**
     * Constructor for objects of class World4.
     * 
     */
    public World4()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(1172, 800, 1); 
        //objects here
        prepare();
        generateGoon();
        player_ = new ship();
        addObject(player_, 538, 608);
        generateTreska();
        
        //spawn timer & ints here
        canSpawn_ = 200;
        spawn_ = canSpawn_;
        
        //health lables here
        health_ = new Lable(100,30);
        health_.setFontSize(20);
        health_.setColor(Color.WHITE);
        health_.setText("Health 100/100");
        int healthX = getWidth() - health_.getImage().getWidth()/2-5;
        int healthY = health_.getImage().getHeight()/2+5;
        addObject(health_, healthX, healthY);
        
        //sounds here
    }
    
    public void act()
    {
        health_.setText("Health " + player_.getHealth() + "/100");
        
        if(player_.getWorld() == null)
        {
            Lable gameOver = new Lable(400, 100);
            gameOver.setColor(Color.RED);
            gameOver.setFontSize(40);
            gameOver.setText("Game Over");
            addObject(gameOver, getWidth()/2, getHeight()/2);
            
            Greenfoot.stop();
        }
        
        //a list of objects to change levels
        List <Treska> treska = getObjects(Treska.class);
        List <Goon> goons = getObjects(Goon.class);
        
        if(treska.size() <= 0 && goons.size() <= 0)
        {
            World5 world = new World5();
            Greenfoot.setWorld(world);
        }
        
        generateRunner();
    }
    
    private void prepare()
    {
        Base base = new Base();
        addObject(base, 548, 740);
        base.setLocation(548, 741);
        Cover cover = new Cover();
        addObject(cover, 62, 675);
        Cover cover2 = new Cover();
        addObject(cover2, 93, 679);
        Cover cover3 = new Cover();
        addObject(cover3, 142, 675);
        Cover cover4 = new Cover();
        addObject(cover4, 192, 671);
        Cover cover5 = new Cover();
        addObject(cover5, 404, 653);
        Cover cover6 = new Cover();
        addObject(cover6, 429, 648);
        Cover cover7 = new Cover();
        addObject(cover7, 478, 651);
        Cover cover8 = new Cover();
        addObject(cover8, 526, 647);
        Cover cover9 = new Cover();
        addObject(cover9, 673, 637);
        Cover cover10 = new Cover();
        addObject(cover10, 721, 633);
        Cover cover11 = new Cover();
        addObject(cover11, 752, 637);
        Cover cover12 = new Cover();
        addObject(cover12, 827, 637);
        Cover cover13 = new Cover();
        addObject(cover13, 888, 640);
        Cover cover14 = new Cover();
        addObject(cover14, 1005, 640);
        Cover cover15 = new Cover();
        addObject(cover15, 1043, 633);
        Cover cover16 = new Cover();
        addObject(cover16, 1076, 644);
        Cover cover17 = new Cover();
        addObject(cover17, 1102, 649);
        Cover cover18 = new Cover();
        addObject(cover18, 1133, 648);
        cover15.setLocation(1036, 640);
        cover16.setLocation(1066, 640);
        cover17.setLocation(1097, 640);
        cover18.setLocation(857, 637);
        cover13.setLocation(886, 637);
        cover10.setLocation(704, 637);
        cover11.setLocation(735, 637);
        cover6.setLocation(435, 653);
        cover7.setLocation(465, 653);
        cover8.setLocation(495, 653);
        cover2.setLocation(92, 675);
        cover3.setLocation(123, 675);
        cover4.setLocation(154, 675);
        Cover cover19 = new Cover();
        addObject(cover19, 217, 619);
        Cover cover20 = new Cover();
        addObject(cover20, 246, 618);
        Cover cover21 = new Cover();
        addObject(cover21, 275, 612);
        Cover cover22 = new Cover();
        addObject(cover22, 308, 622);
        Cover cover23 = new Cover();
        addObject(cover23, 582, 589);
        Cover cover24 = new Cover();
        addObject(cover24, 615, 588);
        Cover cover25 = new Cover();
        addObject(cover25, 653, 588);
        cover20.setLocation(248, 619);
        cover21.setLocation(278, 620);
        cover21.setLocation(278, 619);
        cover22.setLocation(309, 619);
        cover24.setLocation(612, 589);
        cover25.setLocation(643, 589);
        Cover cover26 = new Cover();
        addObject(cover26, 449, 644);
        Cover cover27 = new Cover();
        addObject(cover27, 455, 635);
        Cover cover28 = new Cover();
        addObject(cover28, 455, 626);
        Cover cover29 = new Cover();
        addObject(cover29, 451, 621);
        cover27.setLocation(449, 635);
        cover29.setLocation(452, 617);
        cover28.setLocation(448, 626);
        cover29.setLocation(449, 617);
        Cover cover30 = new Cover();
        addObject(cover30, 712, 631);
        cover30.setLocation(705, 628);
        Cover cover31 = new Cover();
        addObject(cover31, 707, 609);
        Cover cover32 = new Cover();
        addObject(cover32, 711, 615);
        cover32.setLocation(705, 618);
        cover31.setLocation(705, 608);
        cover32.setLocation(705, 619);
        cover31.setLocation(705, 609);
        Cover cover33 = new Cover();
        addObject(cover33, 702, 589);
        cover33.setLocation(705, 600);
        Cover cover34 = new Cover();
        addObject(cover34, 129, 662);
        Cover cover35 = new Cover();
        addObject(cover35, 137, 653);
        cover34.setLocation(125, 666);
        cover35.setLocation(125, 657);
        Cover cover36 = new Cover();
        addObject(cover36, 284, 604);
        cover36.setLocation(279, 609);
        Cover cover37 = new Cover();
        addObject(cover37, 281, 580);
        cover37.setLocation(279, 599);
        Cover cover38 = new Cover();
        addObject(cover38, 863, 627);
        cover38.setLocation(857, 627);
        Cover cover39 = new Cover();
        addObject(cover39, 856, 602);
        cover39.setLocation(857, 618);
        cover39.setLocation(857, 617);
        cover35.setLocation(130, 593);
        cover34.setLocation(130, 603);
        cover3.setLocation(130, 613);
        cover4.setLocation(162, 613);
        cover2.setLocation(98, 615);
        cover.setLocation(66, 615);
        cover4.setLocation(159, 613);
        cover2.setLocation(99, 613);
        cover.setLocation(68, 613);
        cover19.setLocation(217, 611);
        cover20.setLocation(248, 611);
        cover37.setLocation(280, 590);
        cover36.setLocation(281, 600);
        cover21.setLocation(278, 612);
        cover21.setLocation(278, 611);
        cover22.setLocation(309, 611);
        cover36.setLocation(277, 602);
        cover36.setLocation(277, 601);
        cover37.setLocation(277, 592);
        cover5.setLocation(380, 610);
        cover6.setLocation(411, 610);
        cover29.setLocation(442, 610);
        cover7.setLocation(473, 610);
        cover8.setLocation(551, 589);
        cover28.setLocation(736, 600);
        cover11.setLocation(767, 600);
        cover9.setLocation(798, 600);
        cover39.setLocation(858, 601);
        cover38.setLocation(889, 601);
        cover13.setLocation(920, 601);
        cover18.setLocation(951, 601);
        cover12.setLocation(981, 601);
        cover31.setLocation(704, 647);
    }
    
    private void generateGoon()
    {
        int x = (int)(Math.random()*1170) + 1;
        int y = (int)(Math.random()*200) + 1;

        for(int goons_ = 0; goons_ <= 20; goons_++)
        {
            Goon goon = new Goon();
            addObject(goon, x, y);
            x = (int)(Math.random()*1170) + 1;
            y = (int)(Math.random()*200) + 1;
        }
        
        spawn_++;
    }
   
    private void generateTreska()
    {
        int x = Greenfoot.getRandomNumber(1171);
        int y = (int)(Math.random()*300) + 200;
        
        for(int treska_ = 0; treska_ <= 8; treska_++)
        {
            Treska treska = new Treska();
            addObject(treska, x, y);
            x = Greenfoot.getRandomNumber(1171);
            y = (int)(Math.random()*400) + 200;
        }
    }
    
    private void generateRunner()
    {
        if(spawn_ == canSpawn_)
        {
            Runner run = new Runner();
            addObject(run, 5, 5);
            spawn_ = 0;
        }
        
        spawn_ ++;
    }
    
}
